#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "util.h"
#include "ranlib.h"
#include "header.h"

int main(int argc, char *argv[]){
  int t,u,p,points;
  long seed1, seed2;
  double vih;

  phrtsd(PHRASE,&seed1, &seed2);
  setall(SEED1, SEED2);
  
  for(u=0;u<UNDERLIERS;++u){
    Price[0][u][0] = INITIAL;
    Prob[0][u][0] = 1.0/UNDERLIERS;
  }

  Max1[0][0] = 0;
  Max2[0][0] = 1;

  if(INITIAL>STRIKE){
    Value_if_exercised[0][0] = INITIAL-STRIKE;
  }else{
    Value_if_exercised[0][0] = 0;
  }

  /* Fill Price[][][], Max1[][], Max2[][], Value_if_exercised[][], last timeslice Value[][] */
  for(t=1;t<TIMESLICES;++t){
    Ignore[t] = 0;
    init_rng(t);
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      generate_point(t,p);
    }
  }

  for(p=0;p<POINTS;++p){
    Value[TIMESLICES-1][p] = Value_if_exercised[TIMESLICES-1][p];
  }





  /* DEBUG */
#if DEBUG
  for(t=0;t<TIMESLICES;++t){
    points=points_on_timeslice(t);

    for(p=0;p<points;++p){
      printf("Price[%i][:][%i]\t",t,p);

      printf("(%6.2f",Price[t][0][p]);
      for(u=1;u<UNDERLIERS;++u){
	printf(", %6.2f",Price[t][u][p]);
      }
      printf(")\t");

      printf("%i\t",Max1[t][p]);
      printf("%i\t",Max2[t][p]);
      printf("%f\n",Value_if_exercised[t][p]);
    }
  }
#endif

  /* Fill Prob[][][] */
/*   if(PROBCUTOFF){ */
/*     for(t=1;t<TIMESLICES-1;++t){ */
/*       points = points_on_timeslice(t); */
/*       for(p=0;p<points;++p){ */
/* 	prob_of_max(t,p); */
/*       } */
/*     } */
/*   }else{ */
/*     for(t=1;t<TIMESLICES-1;++t){ */
/*       points = points_on_timeslice(t); */
/*       for(u=0;u<UNDERLIERS;++u){ */
/* 	for(p=0;p<points;++p){ */
/* 	  Prob[t][u][p] = 1.0/(double)UNDERLIERS; */
/* 	} */
/*       } */
/*     }     */
/*   } */


  /* DEBUG */
#if DEBUG
  for(t=0;t<TIMESLICES;++t){
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      printf("Prob [%i][:][%i](%15g",t,p,Prob[t][0][p]);
      for(u=1;u<UNDERLIERS;++u){
	printf(", %15g",Prob[t][u][p]);
      }
      printf(")\n");
    }
    printf("\n");
  }
#endif

  /* Fill Value[][] */
  for(t=TIMESLICES-2;t>0;--t){
    points = points_on_timeslice(t);
    for(p=0;p<points;++p){
      prob_of_max(t,p);
      vih = mesh_estimate_3(t,p);
      if(vih > Value_if_exercised[t][p]){
	Value[t][p] = vih;
      }else{
	Value[t][p] = Value_if_exercised[t][p];
      }
    }
  }
  vih = mesh_estimate_3(0,0);
  
  if(vih > Value_if_exercised[0][0]){
    Value[0][0] = vih;
  }else{
    Value[0][0] = Value_if_exercised[0][0];
  }

  /* DEBUG */
#if DEBUG
  for(t=0;t<TIMESLICES;++t){
    points=points_on_timeslice(t);

    for(p=0;p<points;++p){
      printf("Value[%i][%i] = %f\n",t,p,Value[t][p]);
    }
  }
#endif

  printf("Value = %f\n",Value[0][0]);

  for(t=0;t<TIMESLICES;++t){
    printf("%i %f\n",t,Ignore[t]);
  }

  exit(0);
}

int points_on_timeslice(int t){
  int c;

  c = (POINTS-MINPOINTS)/pow(EXPIRATION,POWER);
  return(MINPOINTS + c*pow(EXPIRATION*(double)t/(TIMESLICES-1),POWER));
}

 
